/*** IO utility for reading setfile ***/
/*** Gererated by Dr. Kim's CSTART  ***/

#include <stdio.h>
#include <strings.h>
#include <unistd.h>
#if defined(_IBMR2) || defined (AIX) || defined(hpux)
#include <fcntl.h>
#else
#include <sys/fcntl.h>
#endif
#define MAX_LEN 80

typedef  double TYPE;
typedef  double ATYPE;
typedef  double VTYPE;
typedef  float DTYPE;

void setups(char*setfile,VTYPE*at,VTYPE*bt,int*nt,int*nfield,int*order,int*level,int*itest,int*ierr)
{
   char Program[MAX_LEN];
   char Author[MAX_LEN];
   char atype[MAX_LEN];
   char vtype[MAX_LEN];
   char Arr[MAX_LEN];
   char narr[MAX_LEN];
   char wksp[MAX_LEN];
   char nwksp[MAX_LEN];
   char Headers[MAX_LEN];
   char Calls[MAX_LEN];

   FILE *fp000;

   if ((fp000=fopen(setfile,"r"))==NULL){
       printf("Error in SETUPS: when try to open <%s>\n",setfile);
       *ierr=1;return;}
   fscanf(fp000,"Program=%s Author=%s at=%lg bt=%lg nt=%d nfield=%d order=%d level=%d itest=%d atype=%s vtype=%s Arr=%s narr=%s wksp=%s nwksp=%s Headers=%s Calls=%s",
          Program,Author,at,bt,nt,nfield,order,level,itest,atype,vtype,Arr,narr,wksp,nwksp,Headers,Calls);
   if(*level>=1) printf("SETUPS: from <%s>\n",setfile);
   if(*level>=3) {
      printf(" Program=%s Author=%s\n",Program,Author);
      printf(" at=%lg bt=%lg\n",*at,*bt);
      printf(" nt=%d nfield=%d\n",*nt,*nfield);
      printf(" order=%d level=%d\n",*order,*level);
      printf(" itest=%d atype=%s\n",*itest,atype);
      printf(" vtype=%s Arr=%s\n",vtype,Arr);
      printf(" narr=%s wksp=%s\n",narr,wksp);
      printf(" nwksp=%s Headers=%s\n",nwksp,Headers);
      printf(" Calls=%s\n",Calls);
   }
   fclose(fp000);

  return;
}

