!=======================================================================
      subroutine euler(nt,nfield,at,bt,Y,K,level,ierr)
!=======================================================================
      implicit none
      integer nt,nfield,level,ierr
      real*8 at,bt
      real*8 Y(nfield,0:nt),K(nfield,*)

!--- local variables

      integer n,i
      real*8 ht,tn,time

      ht=(bt-at)/dble(nt)


      if(level.ge.1) print'("EULER:")'
      if(level.ge.2) then
         print*,"at=",at," bt=",bt," nt=",nt," nfield=",nfield
         print*,"ht=",ht
         print*,"Y( 0)=",(Y(i,0),i=1,nfield)
      endif


!--- BEGIN: Euler Method

      do n=0,nt-1

         tn=dble(n)*ht+at

         call evalf(nfield,ht,tn,Y(1,n),K(1,1))

         time=tn+ht

         do i=1,nfield
            Y(i,n+1)=Y(i,n)+K(i,1)
         enddo

         if(level.ge.2) then
            print*,"Y(",n+1,")=",(Y(i,n+1),i=1,nfield)
         endif

      enddo

!--- END: Euler Method


      return
      end

