!=======================================================================
      subroutine rk2(nt,nfield,at,bt,Y,K,level,ierr)
!=======================================================================
      implicit none
      integer nt,nfield,level,ierr
      real*8 at,bt
      real*8 Y(nfield,0:nt),K(nfield,*)

!--- local variables

      integer n,i
      real*8 ht,tn,time,half,ynp(100)

      ht=(bt-at)/dble(nt)
      half=0.5d0


      if(level.ge.1) print'("RK2/Heun/Improved-Euler:")'
      if(level.ge.2) then
         print*,"at=",at," bt=",bt," nt=",nt," nfield=",nfield
         print*,"ht=",ht
         print*,"Y( 0)=",(Y(i,0),i=1,nfield)
      endif


!--- BEGIN: Runge-Kutta 2.

      do n=0,nt-1

         tn=dble(n)*ht+at

         call evalf(nfield,ht,tn,Y(1,n),K(1,1))

         time=tn+ht

         do i=1,nfield
            ynp(i)=Y(i,n)+K(i,1)
         enddo

         call evalf(nfield,ht,time,ynp,K(1,2))

         do i=1,nfield
            Y(i,n+1)=Y(i,n)+half*(K(i,1)+K(i,2))
         enddo

         if(level.ge.2) then
            print*,"Y(",n+1,")=",(Y(i,n+1),i=1,nfield)
         endif

      enddo

!--- END: Runge-Kutta 2.


      return
      end

