!=======================================================================
      subroutine rk4(nt,nfield,at,bt,Y,K,level,ierr)
!=======================================================================
      implicit none
      integer nt,nfield,level,ierr
      real*8 at,bt
      real*8 Y(nfield,0:nt),K(nfield,*)

!--- local variables

      integer n,i,j
      real*8 ht,tn,time,sixth,fstep,ynp(100)

      ht=(bt-at)/dble(nt)
      sixth=1.d0/6.d0


      if(level.ge.1) print'("RK4:")'
      if(level.ge.2) then
         print*,"at=",at," bt=",bt," nt=",nt," nfield=",nfield
         print*,"ht=",ht
         print*,"Y( 0)=",(Y(i,0),i=1,nfield)
      endif


!--- BEGIN: Runge-Kutta 4.

      do n=0,nt-1

         tn=dble(n)*ht+at

         call evalf(nfield,ht,tn,Y(1,n),K(1,1))

         fstep=0.5d0
         time=tn+fstep*ht

         do j=2,4
            if(j.eq.4) then
               fstep=1.0d0
               time=tn+fstep*ht
            endif
            do i=1,nfield
               ynp(i)=Y(i,n)+fstep*K(i,j-1)
            enddo
            call evalf(nfield,ht,time,ynp,K(1,j))
         enddo

         do i=1,nfield
            Y(i,n+1)=Y(i,n)+sixth*(K(i,1)+2.*(K(i,2)+K(i,3))+K(i,4))
         enddo

         if(level.ge.2) then
            print*,"Y(",n+1,")=",(Y(i,n+1),i=1,nfield)
         endif

      enddo

!--- END: Runge-Kutta 4.


      return
      end

